#include <fstream>
#include <sstream>
#include <iostream>

using namespace std;

// How far we want to sample outside the shutter time.
float TIME_EXTENT = 2;

// We generate samples between TIME_START and TIME_END
float TIME_START = 0 - TIME_EXTENT;
float TIME_END = 1 + TIME_EXTENT;

// omega_x_max is calculated per surface

// The bandlimit of the shutter filter. This should always be 1, otherwise, the
// calls to filter_func needs to be updated.
float OMEGA_T_MAX = 1;

// The pixel (image resolution) band limit.
float OMEGA_PIX = 0.5;

// The width and height of the output image.
int IMAGE_WIDTH = 512;
int IMAGE_HEIGHT = 512;

// The name of the scene description rib file.
char RIB_FILENAME[1024];

// Load settings for above variables from a config file.
void LoadConfig(const char *filename) {
  ifstream instream(filename);
  string line;
  while (getline(instream, line)) {
    if (line == "") continue;
    istringstream line_stream(line);
    string var_name;
    line_stream >> var_name;
    if (var_name == "TIME_EXTENT")
      line_stream >> TIME_EXTENT;
    else if (var_name == "RIB_FILENAME")
      line_stream >> RIB_FILENAME;
    else if (var_name == "IMAGE_WIDTH")
      line_stream >> IMAGE_WIDTH;
    else if (var_name == "IMAGE_HEIGHT")
      line_stream >> IMAGE_HEIGHT;
  }
  instream.close();

  TIME_START = 0 - TIME_EXTENT;
  TIME_END = 1 + TIME_EXTENT;
  cout << "config: " << endl
       << "TIME_EXTENT " << TIME_EXTENT << endl
       << "TIME_START " << TIME_START << endl
       << "TIME_END " << TIME_END << endl
       << "OMEGA_PIX " << OMEGA_PIX << endl
       << "IMAGE_DIMENSION " << IMAGE_WIDTH << "x" << IMAGE_HEIGHT << endl
       << "RIB_FILENAME " << RIB_FILENAME << endl;
}
