#ifndef CONFIG_H
#define CONFIG_H

// How far we want to sample outside the shutter time.
extern float TIME_EXTENT;

// We generate samples between TIME_START and TIME_END
extern float TIME_START;
extern float TIME_END;

// The width and height of the output image.
extern int IMAGE_WIDTH;
extern int IMAGE_HEIGHT;

// omega_x_max is calculated per surface

// The bandlimit of the shutter filter. This should always be 1, otherwise, the
// calls to filter_func needs to be updated.
extern float OMEGA_T_MAX;

// The pixel (image resolution) band limit.
extern float OMEGA_PIX;

// The name of the scene description rib file.
extern char RIB_FILENAME[];

// Load settings for above variables from a config file.
void LoadConfig(const char *filename);
#endif
