#include <iostream>

#include "util.h"

using namespace std;

int main(int argc, char* argv[]) {
  if (argc < 4) {
    cout << "You need to specify three filenames" << endl;
  }
  float *data1, *data2, *data3;
  int width1, height1;
  int width2, height2;
  ReadExr(argv[1], data1, width1, height1);
  ReadExr(argv[2], data2, width2, height2);
  if (width1 != width2 || height1 != height2) {
    cout << "ERROR: dimensions mismatch" << endl;
    exit(0);
  }
  data3 = new float[width1 * height1 * 4];
  for (int y = 0; y < height1; y++) {
    for (int x = 0; x < width1; x++) {
      float sum = 0;
      for (int c = 0; c < 3; c++) {
        double v1 = data1[y * width1 * 4 + x * 4 + c];
        double v2 = data2[y * width1 * 4 + x * 4 + c];
        sum += (v1 - v2) * (v1 - v2);
      }
      data3[y* width1 * 4 + x * 4 + 0] = sqrt(sum);
      data3[y* width1 * 4 + x * 4 + 1] = sqrt(sum);
      data3[y* width1 * 4 + x * 4 + 2] = sqrt(sum);
      data3[y* width1 * 4 + x * 4 + 3] = 1;
    }
  }
  WriteExr(argv[3], data3, width1, height1);
}
