#include "render-region.h"
#include "const.h"
#include "config.h"
#include <iostream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

const char *PASS1_SAMPLE_RESULTS_FILENAME;
const char *PASS2_SAMPLE_RESULTS_FILENAME;
const char *PASS1_SAMPLE_INPUT_FILENAME;
const char *PASS2_SAMPLE_INPUT_FILENAME;
int RENDER_TOP;
int RENDER_BOTTOM;
int RENDER_LEFT;
int RENDER_RIGHT;


// TODO some of these files may be more appropriate to dump into /tmp

void setRenderRegion(int region_idx) {
  switch (region_idx) {
    //CAR_NUMBER
    case 0:
    PASS1_SAMPLE_RESULTS_FILENAME =
        "./car-number.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME =
        "./car-number.outputfile.txt.2";
    RENDER_TOP = 200;
    RENDER_BOTTOM = 300;
    RENDER_LEFT = 350;
    RENDER_RIGHT = 450;
    break;

    //BOUNDARY
    case 1:
    PASS1_SAMPLE_RESULTS_FILENAME =
        "./boundary.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME =
        "./boundary.outputfile.txt.2";
    RENDER_TOP = 140;
    RENDER_BOTTOM = 240;
    RENDER_LEFT = 390;
    RENDER_RIGHT = 490;
    break;

    //ALL
    case 2:
    // PASS1_SAMPLE_RESULTS_FILENAME = "sample_results/outputfile.txt.1";
    // PASS2_SAMPLE_RESULTS_FILENAME = "sample_results/outputfile.txt.2";
    PASS1_SAMPLE_RESULTS_FILENAME = "./outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./outputfile.txt.2";
    RENDER_TOP = 0;
    RENDER_BOTTOM = 512;
    RENDER_LEFT = 0;
    RENDER_RIGHT = 512;
    break;

    //Back door
    case 3:
    PASS1_SAMPLE_RESULTS_FILENAME = "./back-door.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./back-door.outputfile.txt.2";
    //RENDER_TOP = 150;
    //RENDER_BOTTOM = 250;
    //RENDER_LEFT = 250;
    //RENDER_RIGHT = 350;
    RENDER_TOP = 190;
    RENDER_BOTTOM = 190;
    RENDER_LEFT = 400;
    RENDER_RIGHT = 512;
    break;

    //Car top
    case 4:
    PASS1_SAMPLE_RESULTS_FILENAME = "./car-top.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./car-top.outputfile.txt.2";
    RENDER_TOP = 100;
    RENDER_BOTTOM = 200;
    RENDER_LEFT = 270;
    RENDER_RIGHT = 370;
    break;

    // shadow
    case 5:
    PASS1_SAMPLE_RESULTS_FILENAME = "./shadow.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./shadow.outputfile.txt.2";
    RENDER_TOP = 320;
    RENDER_BOTTOM = 420;
    RENDER_LEFT = 320;
    RENDER_RIGHT = 420;
    break;

    // background.
    case 6:
    PASS1_SAMPLE_RESULTS_FILENAME = "./background.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./background.outputfile.txt.2";
    RENDER_TOP = 85;
    RENDER_BOTTOM = 125;
    RENDER_LEFT = 320;
    RENDER_RIGHT = 370;
    break;

    // small car top
    case 7:
    PASS1_SAMPLE_RESULTS_FILENAME = "./sct.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./sct.outputfile.txt.2";
    RENDER_TOP = 134;
    RENDER_BOTTOM = 174;
    RENDER_LEFT = 308;
    RENDER_RIGHT = 353;
    break;

    // temp test
    case 8:
    PASS1_SAMPLE_RESULTS_FILENAME = "./temptest.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./temptest.outputfile.txt.2";
    RENDER_TOP = 0;
    RENDER_BOTTOM = 256;
    RENDER_LEFT = 0;
    RENDER_RIGHT = 256;
    break;

    // temp test
    case 9:
    PASS1_SAMPLE_RESULTS_FILENAME = "./temptest.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./temptest.outputfile.txt.2";
    RENDER_TOP = 256;
    RENDER_BOTTOM = 512;
    RENDER_LEFT = 0;
    RENDER_RIGHT = 256;
    break;

    // temp test
    case 10:
    PASS1_SAMPLE_RESULTS_FILENAME = "./temptest.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./temptest.outputfile.txt.2";
    RENDER_TOP = 0;
    RENDER_BOTTOM = 256;
    RENDER_LEFT = 256;
    RENDER_RIGHT = 512;
    break;

    // temp test
    case 11:
    PASS1_SAMPLE_RESULTS_FILENAME = "./temptest.outputfile.txt.1";
    PASS2_SAMPLE_RESULTS_FILENAME = "./temptest.outputfile.txt.2";
    RENDER_TOP = 256;
    RENDER_BOTTOM = 512;
    RENDER_LEFT = 256;
    RENDER_RIGHT = 512;
    break;

  }

  // All render regions use the same sample input filename.
  PASS1_SAMPLE_INPUT_FILENAME = "./pass.1.input";
  PASS2_SAMPLE_INPUT_FILENAME = "./pass.2.input";
}

void setRenderRegionString(const char *s) {
  if (strlen(s) > 0) {
    sscanf(s, "%d,%d,%d,%d", &RENDER_TOP, &RENDER_BOTTOM, &RENDER_LEFT, &RENDER_RIGHT);
    char* BUF_PASS1_SAMPLE_RESULTS_FILENAME = new char[1024];
    char* BUF_PASS2_SAMPLE_RESULTS_FILENAME = new char[1024];
    char* BUF_PASS1_SAMPLE_INPUT_FILENAME = new char[1024];
    char* BUF_PASS2_SAMPLE_INPUT_FILENAME = new char[1024];
    sprintf(BUF_PASS1_SAMPLE_RESULTS_FILENAME,
        "./mrr-%d-%d-%d-%d.outputfile.txt.1", RENDER_TOP, RENDER_BOTTOM, RENDER_LEFT, RENDER_RIGHT);
    sprintf(BUF_PASS2_SAMPLE_RESULTS_FILENAME,
        "./mrr-%d-%d-%d-%d.outputfile.txt.2", RENDER_TOP, RENDER_BOTTOM, RENDER_LEFT, RENDER_RIGHT);
    sprintf(BUF_PASS1_SAMPLE_INPUT_FILENAME,
        "tmp/mrr-%d-%d-%d-%d.outputfile.txt.1", RENDER_TOP, RENDER_BOTTOM, RENDER_LEFT, RENDER_RIGHT);
    sprintf(BUF_PASS2_SAMPLE_INPUT_FILENAME,
        "tmp/mrr-%d-%d-%d-%d.outputfile.txt.2", RENDER_TOP, RENDER_BOTTOM, RENDER_LEFT, RENDER_RIGHT);
    if (RENDER_TOP < 0 || RENDER_LEFT < 0 || RENDER_BOTTOM >= IMAGE_HEIGHT || RENDER_RIGHT >= IMAGE_WIDTH ||
        RENDER_BOTTOM < RENDER_TOP || RENDER_RIGHT < RENDER_LEFT) {
      cout << "Bad render region: "
         << RENDER_TOP << ", "
         << RENDER_BOTTOM << ", "
         << RENDER_LEFT << ", "
         << RENDER_RIGHT << endl;
      exit(1);
    }
    PASS1_SAMPLE_RESULTS_FILENAME = BUF_PASS1_SAMPLE_RESULTS_FILENAME;
    PASS2_SAMPLE_RESULTS_FILENAME = BUF_PASS2_SAMPLE_RESULTS_FILENAME;
    PASS1_SAMPLE_INPUT_FILENAME = BUF_PASS1_SAMPLE_INPUT_FILENAME;
    PASS2_SAMPLE_INPUT_FILENAME = BUF_PASS2_SAMPLE_INPUT_FILENAME;
  }
}
